# This AWK runs on ell but not on owl.
set rtt=0.06
set filename=analysis.ps
set label="SACK TCP"
set infile=dropband.data
#set packetsize=512
set packetsize=1460
set pkt=$packetsize
set top=1250
# to plot packet drop fraction vs. bandwidth in KBps
# SIMPLE FORMULA
#echo "test" > t
# With the new formula, the line stops at 300 KBps.  Why?
#awk '(NR==1){for (i=0.0003; i<0.001; i+=0.0001){print i*100, \
# 1.22 * '$packetsize'/('$rtt'*1000*sqrt(i))}}' t > analysis.$packetsize.data
#awk '(NR==1){for (i=0.001; i<=0.10; i+=0.001){print i*100, \
# 1.22 * '$packetsize'/('$rtt'*1000*sqrt(i))}}' t >> analysis.$packetsize.data
##
# Factor of 1 FORMULA
#echo "test" > t
# With the new formula, the line stops at 300 KBps.  Why?
# awk '(NR==1){for (i=0.0003; i<0.001; i+=0.0001){print i*100, \
#  1.22 * '$packetsize'/('$rtt'*1000*i)}}' t > analysis.1.$packetsize.data
# awk '(NR==1){for (i=0.001; i<=0.40; i+=0.001){print i*100, \
#  1.22 * '$packetsize'/('$rtt'*1000*i)}}' t >> analysis.1.$packetsize.data
##
# UMASS FORMULA
# echo "test" > t
# awk '(NR==1){for (i=0.001; i<=0.10; i+=0.001){print i*100, \
#  0.001*'$pkt'/('$rtt'*sqrt(2*i/3)+2*'$rtt'*3*sqrt(3*i/8)*i*(1+32*i*i))}}' t \
#  > analysis.UM.$pkt.data
# awk '(NR==1){for (i=0.15; i<=0.5; i+=0.05){print i*100, \
#  0.001*'$pkt'/('$rtt'*sqrt(2*i/3)+2*'$rtt'*3*sqrt(3*i/8)*i*(1+32*i*i))}}' t \
#  >> analysis.UM.$pkt.data
##
# Straw FORMULA
# echo "test" > t
# awk '(NR==1){for (i=0.001; i<=0.04; i+=0.001){print i*100, \
#  0.001*'$pkt'/('$rtt'*sqrt(2*i/3))}}' t \
#  > analysis.straw.$pkt.data
# awk '(NR==1){for (i=0.05; i<=0.29; i+=0.01){print i*100, \
#  0.001*'$pkt'/('$rtt'*sqrt(2*i/3)+2*'$rtt'*3*4*(i-0.04)*i*(1+32*i*i))}}' t \
#  >> analysis.straw.$pkt.data
##
## the input: packet drop rate, TCP goodput
## the output:  packet drop rate, TCP sending rate
awk '{printf "%8.5f %7.3f\n", $1, $2*(100)/(100-$1)}' dropband.data | sort > chart1
awk '{printf "%8.5f %7.3f\n", $1, $2*(100)/(100-$1)}' dropband.data2 | sort > chart2
awk '{printf "%8.5f %7.3f\n", $1, $2*(100)/(100-$1)}' dropband.data3 | sort > chart3
awk '{printf "%8.5f %7.3f\n", $1, $2*(100)/(100-$1)}' dropband.data4 | sort > chart4
awk '{printf "%8.5f %7.3f\n", $1, $2*(100)/(100-$1)}' dropband.data5 | sort > chart5
awk '{printf "%8.5f %7.3f\n", $1, $2*(100)/(100-$1)}' dropband.data6 | sort > chart6
s << !
chart _ matrix(scan("analysis.$packetsize.data"),ncol=2,byr=T)
#chart9 _ matrix(scan("analysis.1.$packetsize.data"),ncol=2,byr=T)
chart7 _ matrix(scan("analysis.UM.$packetsize.data"),ncol=2,byr=T)
#chart8 _ matrix(scan("analysis.straw.$packetsize.data"),ncol=2,byr=T)
chart1 _ matrix(scan("chart2"),ncol=2,byr=T)
chart2 _ matrix(scan("chart5"),ncol=2,byr=T)
chart3 _ matrix(scan("chart6"),ncol=2,byr=T)
chart4 _ matrix(scan("chart1"),ncol=2,byr=T)
chart5 _ matrix(scan("chart3"),ncol=2,byr=T)
chart6 _ matrix(scan("chart4"),ncol=2,byr=T)
xr _ range(0.01,chart[,1],100)
yr _ range(10,$top)
postscript("tests.ps", horizontal=F, width = 5.5, height = 4.0, colors = 0:1)
par(mgp=c(1,0,0))
par(mar=c(3,2,0,0))
par(tck=0.02)
par(pch=".")
par(cex=0.6)
plot(chart[,1],chart[,2],xlim=xr,ylim=yr,type="n",log="xy",
xlab="Drop Rate (PerCent of Arriving Packets Dropped)",
ylab="TCP-Friendly Arrival Rate (KBps)",
sub="($packetsize-byte packets, 0.06 second roundtrip time)")
points(chart[,1],chart[,2],type="p",pch=".")
lines(chart[,1],chart[,2],type="l")
#points(chart9[,1],chart9[,2],type="p",pch=".")
#lines(chart9[,1],chart9[,2],type="l")
par(lty=4)
points(chart7[,1],chart7[,2],type="p",pch=".")
lines(chart7[,1],chart7[,2],type="l")
par(lty=2)
#points(chart8[,1],chart8[,2],type="p",pch=".")
#lines(chart8[,1],chart8[,2],type="l")
par(lty=3)
lines(chart1[,1],chart1[,2],type="l")
lines(chart2[,1],chart2[,2],type="l")
lines(chart3[,1],chart3[,2],type="l")
lines(chart4[,1],chart4[,2],type="l")
lines(chart5[,1],chart5[,2],type="l")
lines(chart6[,1],chart6[,2],type="l")
points(chart1[,1],chart1[,2],type="p",pch="1")
points(chart2[,1],chart2[,2],type="p",pch="2")
points(chart3[,1],chart3[,2],type="p",pch="3")
points(chart4[,1],chart4[,2],type="p",pch="4")
points(chart5[,1],chart5[,2],type="p",pch="5")
points(chart6[,1],chart6[,2],type="p",pch="6")
q()
!
#cp tests.ps ~/paper/red/penalty/figures/$filename
