# This AWK runs on ell but not on owl.
set rtt=0.06
set filename=analysis.ps
set label="SACK TCP"
set infile=dropband1.data1
#set packetsize=512
set packetsize=1460
set pkt=$packetsize
set top=1250
# to plot packet drop fraction vs. bandwidth in KBps
# SIMPLE FORMULA
echo "test" > t
# With the new formula, the line stops at 300 KBps.  Why?
awk '(NR==1){for (i=0.0003; i<0.001; i+=0.0001){print i*100, \
 1.22 * '$packetsize'/('$rtt'*1000*sqrt(i))}}' t > analysis.$packetsize.data
awk '(NR==1){for (i=0.001; i<=0.10; i+=0.001){print i*100, \
 1.22 * '$packetsize'/('$rtt'*1000*sqrt(i))}}' t >> analysis.$packetsize.data
##
# Factor of 1 FORMULA
#echo "test" > t
# With the new formula, the line stops at 300 KBps.  Why?
# awk '(NR==1){for (i=0.0003; i<0.001; i+=0.0001){print i*100, \
#  1.22 * '$packetsize'/('$rtt'*1000*i)}}' t > analysis.1.$packetsize.data
# awk '(NR==1){for (i=0.001; i<=0.40; i+=0.001){print i*100, \
#  1.22 * '$packetsize'/('$rtt'*1000*i)}}' t >> analysis.1.$packetsize.data
##
# UMASS FORMULA
echo "test" > t
awk '(NR==1){for (i=0.001; i<=0.10; i+=0.001){print i*100, \
 0.001*'$pkt'/('$rtt'*sqrt(2*i/3)+2*'$rtt'*3*sqrt(3*i/8)*i*(1+32*i*i))}}' t \
 > analysis.UM.$pkt.data
awk '(NR==1){for (i=0.15; i<=0.5; i+=0.05){print i*100, \
 0.001*'$pkt'/('$rtt'*sqrt(2*i/3)+2*'$rtt'*3*sqrt(3*i/8)*i*(1+32*i*i))}}' t \
 >> analysis.UM.$pkt.data
##
# Straw FORMULA
echo "test" > t
awk '(NR==1){for (i=0.001; i<=0.04; i+=0.001){print i*100, \
 0.001*'$pkt'/('$rtt'*sqrt(2*i/3))}}' t \
 > analysis.straw.$pkt.data
awk '(NR==1){for (i=0.05; i<=0.29; i+=0.01){print i*100, \
 0.001*'$pkt'/('$rtt'*sqrt(2*i/3)+2*'$rtt'*3*4*(i-0.04)*i*(1+32*i*i))}}' t \
 >> analysis.straw.$pkt.data
##
s << !
chart _ matrix(scan("analysis.$packetsize.data"),ncol=2,byr=T)
chart7 _ matrix(scan("analysis.UM.$packetsize.data"),ncol=2,byr=T)
chart8 _ matrix(scan("analysis.straw.$packetsize.data"),ncol=2,byr=T)
xr _ range(0.01,chart[,1],100)
yr _ range(10,$top)
postscript("tests.ps", horizontal=F, width = 5.5, height = 4.0, colors = 0:1)
par(mgp=c(1,0,0))
par(mar=c(3,2,0,0))
par(tck=0.02)
par(pch=".")
par(cex=0.6)
plot(chart[,1],chart[,2],xlim=xr,ylim=yr,type="n",log="xy",
xlab="Drop Rate (PerCent of Arriving Packets Dropped)",
ylab="TCP-Friendly Arrival Rate (KBps)",
sub="($packetsize-byte packets, 0.06 second roundtrip time)")
points(chart[,1],chart[,2],type="p",pch=".")
lines(chart[,1],chart[,2],type="l")
par(lty=4)
points(chart7[,1],chart7[,2],type="p",pch=".")
lines(chart7[,1],chart7[,2],type="l")
par(lty=2)
points(chart8[,1],chart8[,2],type="p",pch=".")
lines(chart8[,1],chart8[,2],type="l")
q()
!
